package com.gyee.table.controller;

import com.alibaba.fastjson2.JSONObject;
import com.gyee.table.entity.TableHeaderColumn;
import com.gyee.table.mapper.ObjectAllMapper;
import com.gyee.table.result.Result;
import com.gyee.table.result.ResultCode;
import com.gyee.table.service.IObjectService;
import com.gyee.table.service.ITableHeaderColumnService;
import com.gyee.table.service.ITableHeaderService;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.Arrays;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author gfhd
 * @since 2023-01-11
 */
@RestController
@RequestMapping("/table")
public class TableHeaderController {

    @Resource
    private ITableHeaderService tableHeaderService;
    @Resource
    private ITableHeaderColumnService tableHeaderColumnService;
    @Resource
    private IObjectService objectService;

    private final static String regex = "#|/\\*|\\*/|--|\\buse\\b|\\binsert\\b|\\bdelete\\b|\\bupdate\\b|\\bcreate\\b|\\bdrop\\b|\\btruncate\\b|\\balter\\b|\\bgrant\\b|\\bexecute\\b|\\bexec\\b|\\bxp_cmdshell\\b|\\bcall\\b|\\bdeclare\\b|\\bsource\\b|\\bsql\\b|\\bchr\\b|\\bmid\\b|\\bmaster\\b|\\bchar\\b|\\bsitename\\b|\\bnet user\\b|;|-|\\+|,|\\btable\\b|\\bgroup_concat\\b|\\bcolumn_name\\b|\\binformation_schema.columns\\b|\\btable_schema\\b|//|/";

    @GetMapping("/header/{headername}")
    private List<TableHeaderColumn> header(@PathVariable String headername){
        List<TableHeaderColumn> header = tableHeaderService.getHeader(headername);
        //tableHeaderColumnService.saveBatch(header);
        return header;
    }
    @PostMapping("/data")
    private JSONObject getData(@RequestBody Map map){
        return objectService.selectBySql(map);
    }

    @GetMapping("/test")
    private JSONObject test(){
        //List<TableHeaderColumn> list = tableHeaderColumnService.list();
        return Result.successData(ResultCode.SUCCESS,null);
    }
}
