package com.gyee.table.entity;

import com.alibaba.fastjson2.JSON;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonRawValue;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;

import java.io.Serializable;

/**
 * <p>
 * 
 * </p>
 *
 * @author gfhd
 * @since 2023-01-12
 */
@TableName("table_header_column")
public class TableHeaderColumn implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(type = IdType.ASSIGN_ID)
    private String id;

    private String type;

    private String label;

    private String width;

    private String minwidth;

    private String prop;

    private String align;

    private Boolean showoverflowtooltip;

    private Boolean sortable;

    @TableField(exist = false)
    private String[] operations;

    @TableField(exist = false)
    private String[] children;

    private Boolean showfilters;

    private String filterstype;

    @TableField(exist = false)
    private String[] filters;

    private String formattype;

    @TableField(exist = false)
    private String[] format;

    @JsonIgnore
    private String operationstr;

    @JsonIgnore
    private String childrenstr;

    @JsonIgnore
    private String filterstr;

    @JsonIgnore
    private String formatstr;

    @JsonIgnore
    @TableField(exist = false)
    private ObjectMapper mapper = new ObjectMapper();

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getLabel() {
        return label;
    }

    public void setLabel(String label) {
        this.label = label;
    }

    public String getWidth() {
        return width;
    }

    public void setWidth(String width) {
        this.width = width;
    }

    public String getMinwidth() {
        return minwidth;
    }

    public void setMinwidth(String minwidth) {
        this.minwidth = minwidth;
    }

    public String getProp() {
        return prop;
    }

    public void setProp(String prop) {
        this.prop = prop;
    }

    public String getAlign() {
        return align;
    }

    public void setAlign(String align) {
        this.align = align;
    }

    public Boolean getShowoverflowtooltip() {
        return showoverflowtooltip;
    }

    public void setShowoverflowtooltip(Boolean showoverflowtooltip) {
        this.showoverflowtooltip = showoverflowtooltip;
    }

    public Boolean getSortable() {
        return sortable;
    }

    public void setSortable(Boolean sortable) {
        this.sortable = sortable;
    }

    public Boolean getShowfilters() {
        return showfilters;
    }

    public void setShowfilters(Boolean showfilters) {
        this.showfilters = showfilters;
    }

    public String getFilterstype() {
        return filterstype;
    }

    public void setFilterstype(String filterstype) {
        this.filterstype = filterstype;
    }

    public String getFormattype() {
        return formattype;
    }

    public void setFormattype(String formattype) {
        this.formattype = formattype;
    }

    public String getOperationstr() {
        return JSON.toJSONString(this.operations);
    }

    public void setOperationstr(String operationstr) {
        this.operationstr = operationstr;
    }

    public String getChildrenstr() {
        return JSON.toJSONString(this.children);
    }

    public void setChildrenstr(String childrenstr) {
        this.childrenstr = childrenstr;
    }

    public String getFilterstr() {
        return JSON.toJSONString(this.filters);
    }

    public void setFilterstr(String filterstr) {
        this.filterstr = filterstr;
    }

    public String getFormatstr() {
        return JSON.toJSONString(this.format);
    }

    public void setFormatstr(String formatstr) {
        this.formatstr = formatstr;
    }

    public String[] getOperations() {
        return JSON.parseObject(operationstr,String[].class);
    }

    public void setOperations(String[] operations) {
        this.operations = operations;
    }

    public String[] getChildren() {
        return JSON.parseObject(childrenstr,String[].class);
    }

    public void setChildren(String[] children) {
        this.children = children;
    }

    public String[] getFilters() {
        return JSON.parseObject(filterstr,String[].class);
    }

    public void setFilters(String[] filters) {
        this.filters = filters;
    }

    public String[] getFormat() {
        return JSON.parseObject(formatstr,String[].class);
    }

    public void setFormat(String[] format) {
        this.format = format;
    }
}
