package com.gyee.table.service.impl;

import com.alibaba.fastjson2.JSONObject;
import com.gyee.table.mapper.ObjectAllMapper;
import com.gyee.table.result.Result;
import com.gyee.table.result.ResultCode;
import com.gyee.table.service.IObjectService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author gfhd
 * @since 2023-01-11
 */
@Service
public class ObjectServiceImpl implements IObjectService {

    private final static String regex = "#|/\\*|\\*/|--|\\buse\\b|\\binsert\\b|\\bdelete\\b|\\bupdate\\b|\\bcreate\\b|\\bdrop\\b|\\btruncate\\b|\\balter\\b|\\bgrant\\b|\\bexecute\\b|\\bexec\\b|\\bxp_cmdshell\\b|\\bcall\\b|\\bdeclare\\b|\\bsource\\b|\\bsql\\b|\\bchr\\b|\\bmid\\b|\\bmaster\\b|\\bchar\\b|\\bsitename\\b|\\bnet user\\b|;|-|\\+|,|\\btable\\b|\\bgroup_concat\\b|\\bcolumn_name\\b|\\binformation_schema.columns\\b|\\btable_schema\\b|//|/";
    private Pattern compile = null;
    {
        compile = Pattern.compile(regex);
    }

    @Resource
    private ObjectAllMapper objectMapper;

    @Override
    public JSONObject selectBySql(Map map) {

        String sql = (String) map.get("sql");
        Matcher matcher = compile.matcher(sql);
        if(matcher.find()){
            String group = matcher.group(0);
            return Result.error(ResultCode.ERROR_UNSUPPORTED_SQL,"查看字符:"+group);
        }
        List<LinkedHashMap<String, Object>> lms = objectMapper.selectAll(sql);
        return Result.successData(ResultCode.SUCCESS,lms);
    }
}
