package com.gyee.table.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.gyee.table.entity.TableHeader;
import com.gyee.table.entity.TableHeaderColumn;
import com.gyee.table.mapper.TableHeaderMapper;
import com.gyee.table.service.ITableHeaderService;
import com.gyee.table.utils.IdWorker;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Random;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author gfhd
 * @since 2023-01-11
 */
@Service
public class TableHeaderServiceImpl extends ServiceImpl<TableHeaderMapper, TableHeader> implements ITableHeaderService {

    // 列类型
    private String[] llx = {"index", "operations",""};
    // 列对齐方式
    private String[] ldqfs = {"left", "center", "right"};
    // 列是否溢出隐藏\开启排序\开启筛选
    private Boolean[] arrayb = {true,false};
    // 列筛选的类型
    private String[] lsxlx = {"basic", "current"};
    private Random random = new Random();
    private ObjectMapper objectMapper=new ObjectMapper();
    private String[] kun = {};

    @Resource
    private IdWorker idWorker;

    @Override
    public List<TableHeaderColumn> getHeader(String headername) {
        List<TableHeaderColumn> tableHeaderColumns = new ArrayList<>();
        int j = random.nextInt(15) + 3;
        for (int i = 0; i < j; i++) {
            TableHeaderColumn thc = new TableHeaderColumn();
            //thc.setId(idWorker.nextIdStr());
            thc.setType(llx[random.nextInt(3)]);
            thc.setLabel("新表头");
            thc.setWidth("");
            thc.setMinwidth("");
            thc.setAlign(ldqfs[random.nextInt(3)]);
            thc.setShowoverflowtooltip(arrayb[random.nextInt(2)]);
            thc.setSortable(arrayb[random.nextInt(2)]);
            thc.setOperations(kun);
            thc.setChildren(kun);
            thc.setShowfilters(arrayb[random.nextInt(2)]);
            thc.setFilterstype(lsxlx[random.nextInt(2)]);
            thc.setFormat(kun);
            thc.setFormattype("");

            if("".equals(thc.getType()) && Arrays.equals(kun,thc.getChildren())){
                thc.setProp("newtableheader");
            }else {
                thc.setProp("");
            }

            String[] nihao = {"你好"};
            String s = "";
            try {
                s = objectMapper.writeValueAsString(nihao);
            } catch (JsonProcessingException e) {
                e.printStackTrace();
            }
            thc.setFilters("current".equals(thc.getFilterstype())?nihao:kun);
            tableHeaderColumns.add(thc);
        }
        return tableHeaderColumns;
    }
}
